// Code generated by software.amazon.smithy.rust.codegen.smithy-rs. DO NOT EDIT.
impl super::Client {
    /// Constructs a fluent builder for the [`ListKeys`](crate::operation::list_keys::builders::ListKeysFluentBuilder) operation.
    /// This operation supports pagination; See [`into_paginator()`](crate::operation::list_keys::builders::ListKeysFluentBuilder::into_paginator).
    ///
    /// - The fluent builder is configurable:
    ///   - [`limit(i32)`](crate::operation::list_keys::builders::ListKeysFluentBuilder::limit) / [`set_limit(Option<i32>)`](crate::operation::list_keys::builders::ListKeysFluentBuilder::set_limit):<br>required: **false**<br><p>Use this parameter to specify the maximum number of items to return. When this value is present, KMS does not return more than the specified number of items, but it might return fewer.</p> <p>This value is optional. If you include a value, it must be between 1 and 1000, inclusive. If you do not include a value, it defaults to 100.</p><br>
    ///   - [`marker(impl Into<String>)`](crate::operation::list_keys::builders::ListKeysFluentBuilder::marker) / [`set_marker(Option<String>)`](crate::operation::list_keys::builders::ListKeysFluentBuilder::set_marker):<br>required: **false**<br><p>Use this parameter in a subsequent request after you receive a response with truncated results. Set it to the value of <code>NextMarker</code> from the truncated response you just received.</p><br>
    /// - On success, responds with [`ListKeysOutput`](crate::operation::list_keys::ListKeysOutput) with field(s):
    ///   - [`keys(Option<Vec::<KeyListEntry>>)`](crate::operation::list_keys::ListKeysOutput::keys): <p>A list of KMS keys.</p>
    ///   - [`next_marker(Option<String>)`](crate::operation::list_keys::ListKeysOutput::next_marker): <p>When <code>Truncated</code> is true, this element is present and contains the value to use for the <code>Marker</code> parameter in a subsequent request.</p>
    ///   - [`truncated(bool)`](crate::operation::list_keys::ListKeysOutput::truncated): <p>A flag that indicates whether there are more items in the list. When this value is true, the list in this response is truncated. To get more items, pass the value of the <code>NextMarker</code> element in thisresponse to the <code>Marker</code> parameter in a subsequent request.</p>
    /// - On failure, responds with [`SdkError<ListKeysError>`](crate::operation::list_keys::ListKeysError)
    pub fn list_keys(&self) -> crate::operation::list_keys::builders::ListKeysFluentBuilder {
        crate::operation::list_keys::builders::ListKeysFluentBuilder::new(self.handle.clone())
    }
}
